var apiServer = "https://api.kyk1651.com"; //"http://192.168.1.212:8008"; //
//var apiServer ="http://192.168.1.203:8088";
/*
 * GET方式调用接口
 * url：接口地址
 * callback：回调方法
 * [bool] autoShowLogin：登录超时是否自动显示登录框，默认为true
 */
function apiGet(url, callback, autoShowLogin) {
	//var url = arguments[0];
	//var parms = typeof (arguments[1]) == "object" ? arguments[1] : null;
	//var callback = typeof (arguments[1]) == "function" ? arguments[1] : arguments[2];
	if(autoShowLogin == null) {
		autoShowLogin = true;
	}

	var apiUrl = apiServer + url + (url.indexOf("?") > -1 ? "&" : "?") + "token=" + app.getState().Token;
	apiUrl += "&_=" + Date.parse(new Date());
	apiUrl += '&uuid=' + plus.device.uuid;
	apiUrl += '&conn=' + plus.networkinfo.getCurrentType();

	//console.log(apiUrl);

	mui.ajax(apiUrl, {
		type: "get",
		dataType: "json",
		cache: false,
		timeout: 30000,
		success: function(r) {
			if(r.code == -1 && autoShowLogin == true) {
				app.setState(null);
				var parms = {
					href: "login.html",
					titleType: "native",
					titleText: "用户登录",
					sourceWebViewId: plus.webview.currentWebview().id
				};
				showLogin(parms);
			} else {
				callback(r);
			}
		},
		error: function(XMLHttpRequest, textStatus, errorThrown) {
			console.log(errorThrown);
			mui.toast("网络访问超时");
		}
	});
}

/*
 * POST方式调用接口
 * url：接口地址
 * postData：提交数据
 * callback：回调方法
 * [bool] autoShowLogin：登录超时是否自动显示登录框，默认为true
 */
function apiPost(url, postData, callback, autoShowLogin) {

	if(autoShowLogin == null) {
		autoShowLogin = true;
	}
	

	
	var apiUrl = apiServer + url + (url.indexOf("?") > -1 ? "&" : "?") + "Token=" + app.getState().Token;
	apiUrl += "&_=" + Date.parse(new Date());
	apiUrl += '&uuid=' + plus.device.uuid;
	apiUrl += '&conn=' + plus.networkinfo.getCurrentType();

	mui.ajax({
		url: apiUrl,
		type: "post",
		dataType: "json",
		crossDomain: true,
		//contentType: "application/json",
		//data: JSON.stringify(postData),
		data: postData,
		timeout: 30000,
		cache: false,
		headers: {
			"Content-Type": "application/x-www-form-urlencoded",
			"Origin": "http://api.kyk1651.com" //apiServer
		},
		success: function(r) {
			if(r.code == -1 && autoShowLogin == true) {
				app.setState(null);
				var parms = {
					href: "login.html",
					titleType: "native",
					titleText: "用户登录",
					sourceWebViewId: plus.webview.currentWebview().id
				};
				showLogin(parms);
			} else {
				callback(r);
			}
		},
		error: function(XMLHttpRequest, textStatus, errorThrown) {
			console.log(errorThrown);
			mui.toast("网络访问超时");
		}
	});
}

/*
 * 显示登录界面
 */
function showLogin(parms) {
	var wv_login = mui.openWindow({
		url: "login.html",
		id: "login",
		show: {
			autoShow: true,
			aniShow: "slide-in-bottom"
		},
		styles: {
			popGesture: "close",
			titleNView: {
				autoBackButton: true,
				backgroundColor: '#f7f7f7',
				titleText: "登录",
				//type: "native",
				type: "transparent",
				splitLine: {
					color: '#cccccc'
				}
			}
		},
		waiting: {
			autoShow: false
		},
		extras: {
			source: parms
		}
	});
	wv_login.show("slide-in-up");
}

/*
 * 初始化页面a标签
 */
function initA() {
	mui("body").on('tap', 'a', function() {
		//让a标签获得焦点，避免因为焦点在其他输入框内导致点击失效
		this.focus();

		var href = this.getAttribute("href");
		if(!href || href == '' || href.indexOf('#') == 0) {
			return true;
		}

		var parms = {
			href: href || "",
			id: this.getAttribute("id"),
			titleType: this.getAttribute("title-type"),
			titleText: this.getAttribute("title-text"),
			loginCheck: this.getAttribute("login-check"),
			sourceWebViewId: plus.webview.currentWebview().id
		};
		
		parms.wid = this.getAttribute("wid") || parms.href.split(".")[0];
		openPage(parms);
	});
}

/*
 * 打开新页面
 * loginCheck：检查是否登录
 * wid：webview窗口ID，未指定则默认为href
 * titleType：标题栏模式，native：原生、transparent_native：透明渐变导航
 * titleText：标题栏文字
 * href：页面地址
 */
function openPage(parms) {
	var hrefJson = parms.href.toJson();
	if(hrefJson.titleType) {
		parms.titleType = hrefJson.titleType;
		parms.titleText = hrefJson.titleText;
		parms.loginCheck = hrefJson.loginCheck;
	}

	if(parms.loginCheck && parms.loginCheck == "true") {
		var user = app.getState();
		if(!user || !user.Token) {
			showLogin(parms);
			return;
		}
	}

	//非plus环境，直接走href跳转
	if(!mui.os.plus) {
		location.href = href;
		return;
	}

	var id = parms.wid;
	if(!id) {
		if(parms.href.indexOf('.') > -1) {
			id = parms.href.split('.')[0];
		} else {
			id = href;
		}
	}

	if(parms.href) {
		//打开窗口的相关参数
		var options = {
			styles: {
				popGesture: "close",
				//zindex: 1
			},
			extras: hrefJson
		};
		options.extras.source = parms;

		if(id == "case_view") {
			var case_view_webview = plus.webview.getWebviewById("case_view");
			case_view_webview.setStyle({
				popGesture: 'none'
			});
			mui.fire(case_view_webview, 'get_detail', parms.href.toJson());
		}

		if(parms.href.indexOf('http') == 0) {
			options.styles.titleNView = {
				autoBackButton: false,
				backgroundColor: '#f7f7f7',
				splitLine: {
					color: '#cccccc'
				},
				buttons: [{
					fontSrc: '_www/fonts/mui.ttf',
					text: '\ue460',
					float: 'left',
					fontSize: '32px',
					onclick: function(event) {
						plus.webview.close(parms.wid);
					}
				}]
			};

			if(parms.titleText && parms.titleText.length > 0) {
				options.styles.titleNView.titleText = parms.titleText;
			}

			if(parms.wid == 'meida') {
				options.styles.titleNView.buttons.push({
					fontSrc: '_www/fonts/mui.ttf',
					text: '\ue405',
					float: 'right',
					fontSize: '28px',
					onclick: function(event) {
						var _w = plus.webview.getWebviewById(parms.wid);
						mui.fire(_w, 'share', null);
						console.log('share end!');
					}
				})
			}

			options.styles.plusrequire = 'ahead';
			var browser = plus.webview.create(parms.href, id, options.styles, 'auto', 200);
			browser.show();
			return false;
		}

		if(parms.titleType && parms.titleType.indexOf("native") > -1) { //原生导航
			options.styles.titleNView = {
				autoBackButton: true,
				backgroundColor: '#f7f7f7',
				splitLine: {
					color: '#cccccc'
				},
				buttons: []
			};
			//options.show = {
				//autoShow: true
				//event: 'loaded'
			//}
			//有原生标题的情况下，就不需要waiting框了
			options.waiting = {
				autoShow: false
			}
			if(parms.titleText && parms.titleText.length > 0) {
				options.styles.titleNView.titleText = parms.titleText;
			}
			//透明渐变导航,增加类型设置
			if(parms.titleType == "transparent_native") {
				options.styles.titleNView.type = "transparent";
			}
			//积分商品页面增加分享按钮
			if(parms.wid == 'shop_product') {
				options.styles.titleNView.buttons.push({
					fontSrc: '_www/fonts/mui.ttf',
					text: '\ue405',
					float: 'right',
					fontSize: '28px',
					onclick: function(event) {
						var _w = plus.webview.getWebviewById(parms.wid);
						mui.fire(_w, 'share', null);
						console.log('share end!');
					}
				})
			}
		} else {
			//非原生导航，需要设置顶部状态栏占位
			options.styles.statusbar = {
				background: "#f7f7f7"
			}
		}
		
		//console.log('id:' + id + ',parms:' + JSON.stringify(parms) + ', options:' + JSON.stringify(options));

		//打开新窗口
        if(parms.sourceWebViewId=="ad"){
        	mui.openWindow(parms.href, id, options).show();
        }
		else{
			mui.openWindow(parms.href, id, options);
		}
	}
}

(function($, owner) {
	/**
	 * 输出现有所有打开的webview信息
	 **/
	owner.showAllWebViewInfo = function() {
			var all = plus.webview.all();
			console.log("合计打开webview数量：" + all.length);

			for(var i = 0; i < all.length; i++) {
				console.log(all[i].id);
			}
		},

		owner.createState = function(r, callback) {
			owner.setState(r);
			return callback();
		};

	/**
	 * 获取当前状态
	 **/
	owner.getState = function() {
		var stateText = plus.storage.getItem('$state');
		if(stateText != null && stateText != undefined) {
			var s = JSON.parse(stateText);
			if(new Date() > new Date(s.TokenTimeOut)) {
				stateText = "";
			}
		}
		stateText = stateText || '{"ID":0,"FaceImg":"images/defaultUpic.png","Points":0,"RealName":"登录/注册","Type":1,"Token":"","TokenTimeOut":"1970-1-1"}';
		return JSON.parse(stateText);
	};

	/**
	 * 设置当前状态
	 **/
	owner.setState = function(state) {
		state = state || {
			FaceImg: "images/defaultUpic.png",
			Points: 0,
			RealName: "登录/注册",
			Type: 1,
			Token: "",
			TokenTimeOut: "1970-1-1"
		};
		plus.storage.setItem('$state', JSON.stringify(state));
		//localStorage.setItem('$state', state);
	};

	var checkEmail = function(email) {
		email = email || '';
		return(email.length > 3 && email.indexOf('@') > -1);
	};

	/**
	 * 获取应用本地配置
	 **/
	owner.setSettings = function(settings) {
		settings = settings || {};
		plus.storage.setItem('$settings', JSON.stringify(settings));
	}

	/**
	 * 设置应用本地配置
	 **/
	owner.getSettings = function() {
		var settingsText = plus.storage.getItem('$settings') || "{}";
		return JSON.parse(settingsText);
	}
	/**
	 * 获取本地是否安装客户端
	 **/
	owner.isInstalled = function(id) {
		if(id === 'qihoo' && mui.os.plus) {
			return true;
		}
		if(mui.os.android) {
			var main = plus.android.runtimeMainActivity();
			var packageManager = main.getPackageManager();
			var PackageManager = plus.android.importClass(packageManager)
			var packageName = {
				"qq": "com.tencent.mobileqq",
				"weixin": "com.tencent.mm",
				"sinaweibo": "com.sina.weibo"
			}
			try {
				return packageManager.getPackageInfo(packageName[id], PackageManager.GET_ACTIVITIES);
			} catch(e) {}
		} else {
			switch(id) {
				case "qq":
					var TencentOAuth = plus.ios.import("TencentOAuth");
					return TencentOAuth.iphoneQQInstalled();
				case "weixin":
					var WXApi = plus.ios.import("WXApi");
					return WXApi.isWXAppInstalled()
				case "sinaweibo":
					var SinaAPI = plus.ios.import("WeiboSDK");
					return SinaAPI.isWeiboAppInstalled()
				default:
					break;
			}
		}
	}
}(mui, window.app = {}));